;/*******************************/;
;/* 7SEG & LED Scan For ET-EXP4 */;
;/* Files Name  : LAB1-EX3.ASM  */;
;/* CPU Control : MCS51 Family  */;
;/* Assembler   : SXA51.EXE     */;
;/*  (Scan & Swap 7-Seg,LED-8)  */;
;/*******************************/;
;
;/* Port For Control LED
PORT_ROW    EQU     P1                  ; Data Drive 7 Segment
PORT_COL    EQU     P0                  ; Port Colum

            ORG     20H
DSP_BUFF:   DS      5                   ; Display buffer 5 Byte
DSP_CNT:    DS      1
DSP_CODE:   DS      1
COL_SCAN:   DS      1                   ; Colum Buffer Data Scan
DIG_SCAN:   DS      1                   ; 7-Segment Digit Count
STACK:      DS      32

            ORG     0000H               ; Start Monitor of 68HC811E2
MAIN:       MOV     SP,#STACK           ; Stack = 32 Byte
            ;
LOOP1:      MOV     DSP_CODE,#0         ; Index Display
            MOV     DSP_CNT,#16         ; 16 Code Display Count
            ;
LOOP2:      MOV     DSP_BUFF+0,DSP_CODE ; Segment 1
            MOV     DSP_BUFF+1,DSP_CODE ; Segment 2
            MOV     DSP_BUFF+2,DSP_CODE ; Segment 3
            MOV     DSP_BUFF+3,DSP_CODE ; Segment 4
            MOV     DSP_BUFF+4,DSP_CODE ; 8-Bit LED
            ;
            MOV     7,#250              ; Loop Scan Display
LOOP3:      LCALL   SCAN_DSP
            DJNZ    R7,LOOP3
            ;
            INC     DSP_CODE            ; DSP_CODE = DSP_CODE + 1
            DJNZ    DSP_CNT,LOOP2       ; DSP_CNT = DSP_CNT - 1
            LJMP    LOOP1

;/********************************/;
;/* Get Data From Display Buffer */;
;/* and Scan 4 Digits  7-Segment */;
;/* Input = DSP_BUFF(5-Byte)     */;
;/********************************/;
;
SCAN_DSP:   MOV     R0,#DSP_BUFF        ; Display Buffer Code
            MOV     COL_SCAN,#0         ; Colum Multiplex Code
            MOV     DIG_SCAN,#4         ; 4 Digit Counter Scan
            ;
SCAN_DSP1:  MOV     A,@R0               ; Get Right Digit 7-Segment
            MOV     DPTR,#TAB_SEG
            MOVC    A,@A+DPTR           ; Convert to 7-Segment Code
            MOV     PORT_ROW,A
            MOV     PORT_COL,COL_SCAN   ; Active Colum Scan
            ;
            MOV     R2,#2               ; Scan Delay Counter
SCAN_DSP2:  MOV     R3,#250
            DJNZ    R3,$
            DJNZ    R2,SCAN_DSP2
            ;
            INC     R0                  ; Next Row Buffer
            INC     COL_SCAN
            DJNZ    DIG_SCAN,SCAN_DSP1  ; Loop Until Row Complete (4-Seg)
            ;
            MOV     A,@R0               ; Get Buffer LED (DSP_BUFF+4)
            MOV     DPTR,#TAB_LED
            MOVC    A,@A+DPTR
            MOV     PORT_ROW,A
            MOV     PORT_COL,COL_SCAN   ; Active Colum Scan
            ;
            MOV     R2,#2               ; Scan Delay Counter
SCAN_DSP3:  MOV     R3,#250
            DJNZ    R3,$
            DJNZ    R2,SCAN_DSP3
            ;
            MOV     PORT_COL,#5         ; Disable Colum Active
            RET

;/************************/;
;/* Table 7-Segment Code */;
;/*   Dp A B C D E F G   */;
;/*   D7............D0   */;
;/************************/;
;
TAB_SEG:    DB      3FH,06H,5BH,4FH     ; 0 1 2 3
            DB      66H,6DH,7DH,07H     ; 4 5 6 7
            DB      7FH,6FH,77H,7CH     ; 8 9 A B
            DB      39H,5EH,79H,71H     ; C D E F

;/*********************/;
;/* Table LED Display */;
;/*********************/;
;
TAB_LED:    DB      01H,02H,04H,08H     ; 1 2 3 4
            DB      10H,20H,40H,80H     ; 5 6 7 8
            DB      01H,02H,04H,08H     ; 1 2 3 4
            DB      10H,20H,40H,80H     ; 5 6 7 8

            END

