;/*******************************/;
;/* Demo Step Motor For ET-EXP4 */;
;/* Files Name  : LAB5-EX3.ASM  */;
;/* CPU Control : MCS51 Family  */;
;/* Assembler   : SXA51.EXE     */;
;/*      (Full Step Control)    */;
;/*******************************/;
;
;/* Port For Control Stepping Motor
PORT_OUT    EQU     P1                  ; Step,Relay,Spk

            ORG     20H
STEP_CNT:   DS      1
CYCLECNT:   DS      1
STEP_INX:   DS      1
STACK:      DS      32

            ORG     0000H               ; Start Monitor
MAIN:       MOV     SP,#STACK           ; Stack = 32 Byte Internal RAM
            ;
FULL_DRV:   MOV     CYCLECNT,#12
FULL0:      MOV     STEP_CNT,#8         ; 8 Step/1 Cycle Counter
            MOV     STEP_INX,#0
FULL1:      MOV     DPTR,#TAB_FULL1     ; Full Step Drive Table
            LCALL   OUT_STEP            ; Out Signal Drive
            INC     STEP_INX            ; Next Step
            DJNZ    STEP_CNT,FULL1
            DJNZ    CYCLECNT,FULL0
            LCALL   STEP_DLY
            ;
            MOV     CYCLECNT,#12
FULL2:      MOV     STEP_CNT,#8         ; 8 Step/1 Cycle Counter
            MOV     STEP_INX,#0
FULL3:      MOV     DPTR,#TAB_FULL2     ; Full Step Drive Table
            LCALL   OUT_STEP            ; Out Signal Drive
            INC     STEP_INX            ; Next Step
            DJNZ    STEP_CNT,FULL3
            DJNZ    CYCLECNT,FULL2
            LCALL   STEP_DLY
            ;
            LJMP    FULL_DRV            ; Loop Continue

;/********************************/;
;/* Out Stepp Motor Signal Drive */;
;/* Input  : INX  = Table Signal */;
;/*        : Step Index          */;
;/* Output : Port  Signal        */;
;/********************************/;
;
OUT_STEP:   MOV     A,STEP_INX
            MOVC    A,@A+DPTR           ; Get Signal
            MOV     PORT_OUT,A
            ;
            MOV     R2,#200             ; Delay Step Rate
OUT_DLY1:   MOV     R3,#0FFH
            DJNZ    R3,$
            DJNZ    R2,OUT_DLY1
            RET

;/****************/;
;/*  Delay Time  */;
;/****************/;
;
STEP_DLY:   MOV     R2,#20
STEP_DL1:   MOV     R3,#0FFH
STEP_DL2:   MOV     R4,#0FFH
            DJNZ    R4,$
            DJNZ    R3,STEP_DL2
            DJNZ    R2,STEP_DL1
            RET

;/**********************/;
;/* TWO-Phase-ON Drive */;
;/* Normal-Drive       */;
;/* Full Step          */;
;/* TWO-Excitation     */;
;/**********************/;
;
TAB_FULL1:  DB      00000011B           ; Step-2 (Forward)
            DB      00000110B           ; Step-4
            DB      00001100B           ; Step-6
            DB      00001001B           ; Step-8
            DB      00000011B           ; Step-2
            DB      00000110B           ; Step-4
            DB      00001100B           ; Step-6
            DB      00001001B           ; Step-8
            ;
TAB_FULL2:  DB      00001001B           ; Step-8 (Reverse)
            DB      00001100B           ; Step-6
            DB      00000110B           ; Step-4
            DB      00000011B           ; Step-2
            DB      00001001B           ; Step-8
            DB      00001100B           ; Step-6
            DB      00000110B           ; Step-4
            DB      00000011B           ; Step-2

            END

