;/*******************************/;
;/* 7SEG & LED Scan For ET-EXP4 */;
;/* Files Name  : LAB1-EX3.ASM  */;
;/* CPU Control : 68HC811E2     */;
;/* Assembler   : AS11NEW.EXE   */;
;/*  (Scan & Swap 7-Seg,LED-8)  */;
;/*******************************/;
;
;/* Port For Control LED
PORT_ROW    EQU     $1003               ; Data Drive 7 Segment (Port-C)
CTRL_ROW    EQU     $1007               ; DDRC (0=In,1=Out)
PORT_COL    EQU     $1004               ; Port-B

            ORG     $00
DSP_BUFF    RMB     5                   ; Display buffer 5 Byte
DSP_CNT     RMB     1
DSP_CODE    RMB     1
COL_SCAN    RMB     1                   ; Colum Buffer Data Scan
DIG_SCAN    RMB     1                   ; 7-Segment Digit Count

            ORG     $F800               ; Start Monitor of 68HC811E2
MAIN        LDS     #$FF                ; Stack = Last Internal RAM
            LDAB    #$FF
            STAB    CTRL_ROW            ; Port-C = Output
            ;
LOOP1       CLR     DSP_CODE            ; Index Display
            LDAB    #16                 ; 16 Code Display Count
            STAB    DSP_CNT
            ;
LOOP2       LDAB    DSP_CODE            ; Define Code Display
            STAB    DSP_BUFF+0          ; Segment 1
            STAB    DSP_BUFF+1          ; Segment 2
            STAB    DSP_BUFF+2          ; Segment 3
            STAB    DSP_BUFF+3          ; Segment 4
            STAB    DSP_BUFF+4          ; 8-Bit LED
            ;
            LDX     #1000               ; 1000 Loop Scan Display
LOOP3       JSR     SCAN_DSP
            DEX
            BNE     LOOP3
            ;
            INC     DSP_CODE            ; DSP_CODE = DSP_CODE + 1
            DEC     DSP_CNT             ; DSP_CNT = DSP_CNT - 1
            BNE     LOOP2
            BRA     LOOP1

;/********************************/;
;/* Get Data From Display Buffer */;
;/* and Scan 4 Digits  7-Segment */;
;/* Input = DSP_BUFF(5-Byte)     */;
;/********************************/;
;
SCAN_DSP    PSHX
            PSHY
            PSHB
            ;
            LDX     #DSP_BUFF           ; Display Buffer Code
            CLR     COL_SCAN            ; Colum Multiplex Code
            LDAB    #4
            STAB    DIG_SCAN            ; 4 Digit Counter Scan
            ;
SCAN_DSP1   LDAB    0,X                 ; Get Right Digit 7-Segment
            LDY     #TAB_SEG
            ABY
            LDAB    0,Y                 ; Convert to 7-Segment Code
            STAB    PORT_ROW
            LDAB    COL_SCAN
            STAB    PORT_COL            ; Active Colum Scan
            ;
            LDAB     #100               ; Scan Delay Counter
SCAN_DSP2   DECB
            BNE     SCAN_DSP2
            ;
            INX                         ; Next Row Buffer
            INC     COL_SCAN
            DEC     DIG_SCAN
            BNE     SCAN_DSP1           ; Loop Until Row Complete (4-Seg)
            ;
            LDAB    0,X                 ; Get Buffer LED (DSP_BUFF+4)
            LDY     #TAB_LED
            ABY
            LDAB    0,Y
            STAB    PORT_ROW
            LDAB    COL_SCAN
            STAB    PORT_COL            ; Active Colum Scan
            ;
            LDAB    #100                ; Scan Delay Counter
SCAN_DSP3   DECB
            BNE     SCAN_DSP3
            ;
            LDAB    #5
            STAB    PORT_COL            ; Disable Colum Active
            ;
            PULB
            PULY
            PULX
            RTS

;/************************/;
;/* Table 7-Segment Code */;
;/*   Dp A B C D E F G   */;
;/*   D7............D0   */;
;/************************/;
;
TAB_SEG     FCB     $3F,$06,$5B,$4F     ; 0 1 2 3
            FCB     $66,$6D,$7D,$07     ; 4 5 6 7
            FCB     $7F,$6F,$77,$7C     ; 8 9 A B
            FCB     $39,$5E,$79,$71     ; C D E F

;/*********************/;
;/* Table LED Display */;
;/*********************/;
;
TAB_LED     FCB     $01,$02,$04,$08     ; 1 2 3 4
            FCB     $10,$20,$40,$80     ; 5 6 7 8
            FCB     $01,$02,$04,$08     ; 1 2 3 4
            FCB     $10,$20,$40,$80     ; 5 6 7 8

            ORG     $FFFE               ; Reset Vector
            FDB     MAIN

            END

