;/********************************/;
;/* Demo Display 5x7 For ET-EXP4 */;
;/* Files Name  : LAB3-EX2.ASM   */;
;/* CPU Control : 68HC811E2      */;
;/* Assembler   : AS11NEW.EXE    */;
;/*  (Move  Right <-----> Left)  */;
;/********************************/;
;
PORT_DSP    EQU     $1003               ; Port-C
DDRC        EQU     $1007               ; Port-C Direction
;
;/** 74HC595 = Colum Control
COL_RESET   EQU     %00000001           ; Reset  Clock  74HC595 (PC0)
COL_SHIFT   EQU     %00000010           ; Shift  Clock  74HC595 (PC1)
COL_LATCH   EQU     %00000100           ; Latch  Clock  74HC595 (PC2)
COL_ENABLE  EQU     %00001000           ; Enable Output 74HC595 (PC3)
COL_DATA    EQU     %00100000           ; Data   Input  74HC595 (PC5)
;
;/** 4017 = Row Control
ROW_ENABLE  EQU     %00010000           ; Enable 4017           (PC4)
ROW_RESET   EQU     %01000000           ; Reset 4017            (PC6)
ROW_DATA    EQU     %10000000           ; Clock Input 4017      (PC7)

            ORG     $00
DSP_BUFF    RMB     21                  ; Display Buffer (7-Byte : 1 Font)
DATA_INX    RMB     1                   ; Index Get Buffer Display (SCAN_DSP)
BIT_MOVE    RMB     1                   ; Counter Bit Move on 1-Font
INX_MOVE    RMB     1                   ; Index Get Font (Move Left <--> Right)
FONT_CNT    RMB     1                   ; Char Move Count on Style
AUX_BUFF    RMB     2                   ; Aux. Buffer
        
            ORG     $F800               ; Reset Vector
MAIN        LDS     #$FF                ; Stack = Last Internal RAM
            LDAB    #$FF
            STAB    DDRC                ; All Port-C = Output
            ;
            LDAB    #21
            LDX     #DSP_BUFF           ; Clear Display Buffer
            CLRA
CLR_BUFF    STAA    0,X
            INX
            DECB
            BNE     CLR_BUFF
            ;
            ;/* Move Display Right to Left Style
SHF_LEFT    LDAB    #13                 ; 13 Char Move Left (0-9,Sp,Sp,Sp)
            STAB    FONT_CNT
            CLR     INX_MOVE            ; Index Get Font in Table
            ;
            ;/* Get Font From Table to Buffer
SHF_LFT0    LDX     #TAB_FONT           ; Table Font
            STX     AUX_BUFF
            LDAA    INX_MOVE            ; Code to Get Code
            LDAB    #7                  ; 7-Byte : 1-Font
            MUL                         ; AxB = D
            ADDD    AUX_BUFF
            PSHB
            PSHA
            PULX                        ; X = Pointer Font
            LDAB    #7
            LDY     #DSP_BUFF+14        ; Display Buffer Font-4
SHF_LFT1    LDAA    0,X
            STAA    0,Y
            INX
            INY
            DECB
            BNE     SHF_LFT1
            ;
            LDAB    #6                  ; 6-Bit Shift : 1-Font
            STAB    BIT_MOVE
            ;
            ;/* Shift Right to Left 6 Bit : 1-Font
SHF_LFT2    LDX     #DSP_BUFF           ; First Row Buffer
            LDY     #7                  ; 7 Row Shift Count
SHF_LFT3    LDAA    7,X                 ; Get Buffer Font-2
            LDAB    14,X                ; Get Buffer Font-3
            LSLD                        ; CY <-- D15 <-- D0 <-- 0
            STAA    7,X                 ; Update Buffer Font-2
            STAB    14,X                ; Update Buffer Font-3
            LDAA    0,X                 ; Get Buffer Font-1
            ROLA                        ; CY <-- D7 <-- D0 <-- CY
            STAA    0,X                 ; Update Buffer Font-1
            INX                         ; Next Row Shift
            DEY
            BNE     SHF_LFT3
            ;
            LDAB    #50                 ; Display 50 Round Before Next Shift
SHF_LFT4    JSR     SCAN_DSP
            DECB
            BNE     SHF_LFT4
            ;
            DEC     BIT_MOVE            ; Repeat Move 6 Bit
            BNE     SHF_LFT2
            INC     INX_MOVE            ; Shift New Font
            DEC     FONT_CNT            ; Repeat Move 13 Font
            BNE     SHF_LFT0
            ;
            ;/* Move Display Left to Right Style
SHF_RIGHT   LDAB    #13                 ; 13 Char Move Right (0-9,Sp,Sp,Sp)
            STAB    FONT_CNT
            CLR     INX_MOVE            ; Index Font3 in Table 4x7
            ;
            ;/* Get Font From Table to Buffer
SHF_RGT0    LDX     #TAB_FONT           ; Table Font
            STX     AUX_BUFF
            LDAA    INX_MOVE            ; Code to Get Code
            LDAB    #7                  ; 7-Byte : 1-Font
            MUL                         ; AxB = D
            ADDD    AUX_BUFF
            PSHB
            PSHA
            PULX                        ; X = Pointer Font
            LDAB    #7
            LDY     #DSP_BUFF+14        ; Display Buffer Font-4
SHF_RGT1    LDAA    0,X
            LSRA                        ; Shift Font5x7 to Right
            LSRA
            LSRA
            STAA    0,Y
            INX
            INY
            DECB
            BNE     SHF_RGT1
            ;
            LDAB    #6                  ; 6-Bit Shift : 1 Font
            STAB    BIT_MOVE
            ;
            ;/* Shift Left to Right 6 Bit : 1-Font
SHF_RGT2    LDX     #DSP_BUFF           ; First Row Buffer
            LDY     #7                  ; 7 Row Shift Count
SHF_RGT3    LDAA    14,X                ; Get Buffer Font-3
            LDAB    0,X                 ; Get Buffer Font-1
            LSRD                        ; 0 --> D15 --> D0 --> CY
            STAA    14,X                ; Update Buffer Font-3
            STAB    0,X                 ; Update Buffer Font-1
            LDAA    7,X                 ; Get Buffer Font-2
            RORA                        ; CY --> D7--> D0 --> CY
            STAA    7,X                 ; Update Buffer Font-2
            INX                         ; Next Row Shift
            DEY
            BNE     SHF_RGT3
            ;
            LDAB    #50                 ; Display 50 Round Before Next Shift
SHF_RGT4    JSR     SCAN_DSP
            DECB
            BNE     SHF_RGT4
            ;
            DEC     BIT_MOVE            ; Repeat Move 6-Bit
            BNE     SHF_RGT2
            INC     INX_MOVE            ; Shift New Font
            DEC     FONT_CNT            ; Repeat Move 13 Font
            BNE     SHF_RGT0
            JMP     SHF_LEFT

;/********************************/;
;/* Get Data From Display Buffer */;
;/* and Scan Display 3 Dotmatrix */;
;/* Input : DSP_BUFF0..13(14Byte)*/;
;/********************************/;
;
SCAN_DSP    PSHX                        ; Save Register
            PSHA
            PSHB
            ;
            LDX     #PORT_DSP
            BSET    0,X COL_RESET       ; Start 74HC595 Pin
            BCLR    0,X ROW_ENABLE      ; Enable Row Output (4017)
            BSET    0,X ROW_RESET       ; Clear Row Output Scan
            BCLR    0,X ROW_RESET
            ;
            CLR     DATA_INX
            LDAB    #7                  ; 7-Row Counter Scan
SCAN_DSP1   BSET    0,X COL_ENABLE      ; Disable Out Colum (74HC595)
            ;
            PSHB                        ; Save Row Counter
            LDY     #DSP_BUFF+7         ; Display Buffer Font-2
            LDAB    DATA_INX
            ABY
            LDAA    0,Y                 ; Right Digit
            COMA
            JSR     SER_OUT             ; Send Data to Col 0-7
            LDY     #DSP_BUFF+0         ; Display Buffer Font-1
            LDAB    DATA_INX
            ABY
            LDAA    0,Y                 ; Left Digit
            COMA
            JSR     SER_OUT             ; Send Data to Col 8-15
            ;
            BSET    0,X COL_LATCH       ; Latch Data Colum
            BCLR    0,X COL_LATCH
            BSET    0,X ROW_DATA        ; Row Scan = Row Scan+1
            BCLR    0,X ROW_DATA
            BCLR    0,X COL_ENABLE      ; Enable Colum (74HCT595)
            ;
            LDAB    #100
SCAN_DSP2   DECB
            BNE     SCAN_DSP2           ; Delay for EYE
            ;
            INC     DATA_INX            ; Next Row Buffer
            PULB                        ; Restore Row Counter
            DECB
            BNE     SCAN_DSP1           ; Loop Until 7 Row Complete
            ;
            BSET    0,X ROW_DATA        ; Shift Over 1-Row
            BCLR    0,X ROW_DATA
            BSET    0,X ROW_ENABLE      ; Disable Row (4017)
            ;
            PULB                        ; Restore Register
            PULA
            PULX
            RTS

;/*************************/;
;/* Shift Data to 74HC595 */;
;/* Input : ACCA          */;
;/*************************/;
;
SER_OUT     LDAB    #8                  ; Counter data ShiftOut 1 Byte
SHF_OUT     RORA                        ; Shift Out data D0..D7
            BCS     SET_DAT
            BCLR    0,X COL_DATA
            BRA     SHF_CLK
SET_DAT     BSET    0,X COL_DATA
SHF_CLK     BSET    0,X COL_SHIFT       ; Shift Data at Rising Edge
            BCLR    0,X COL_SHIFT
            DECB
            BNE     SHF_OUT             ; Loop Send This Byte
            RTS

;/*********************/;
;/* Table of Font 5x7 */;
;/*********************/;
;
TAB_FONT    FCB     %00110000           ; 0
            FCB     %01001000
            FCB     %01001000
            FCB     %01001000
            FCB     %01001000
            FCB     %01001000
            FCB     %00110000
            ;
            FCB     %00010000           ; 1
            FCB     %00110000
            FCB     %00010000
            FCB     %00010000
            FCB     %00010000
            FCB     %00010000
            FCB     %00111000
            ;
            FCB     %00110000           ; 2
            FCB     %01001000
            FCB     %00001000
            FCB     %00010000
            FCB     %00100000
            FCB     %01000000
            FCB     %01111000
            ;
            FCB     %01111000           ; 3
            FCB     %00010000
            FCB     %00100000
            FCB     %00010000
            FCB     %00001000
            FCB     %01001000
            FCB     %00110000
            ;
            FCB     %01000000           ; 4
            FCB     %01000000
            FCB     %01010000
            FCB     %01010000
            FCB     %01111000
            FCB     %00010000
            FCB     %00010000
            ;
            FCB     %01111000           ; 5
            FCB     %01000000
            FCB     %01110000
            FCB     %00001000
            FCB     %00001000
            FCB     %01001000
            FCB     %00110000
            ;
            FCB     %00010000           ; 6
            FCB     %00100000
            FCB     %01000000
            FCB     %01110000
            FCB     %01001000
            FCB     %01001000
            FCB     %00110000
            ;
            FCB     %01111000           ; 7
            FCB     %00001000
            FCB     %00001000
            FCB     %00010000
            FCB     %00100000
            FCB     %00100000
            FCB     %00100000
            ;
            FCB     %00110000           ; 8
            FCB     %01001000
            FCB     %01001000
            FCB     %00110000
            FCB     %01001000
            FCB     %01001000
            FCB     %00110000
            ;
            FCB     %00110000           ; 9
            FCB     %01001000
            FCB     %01001000
            FCB     %00111000
            FCB     %00001000
            FCB     %00010000
            FCB     %00100000
            ;
            FCB     %00000000           ; Sp
            FCB     %00000000
            FCB     %00000000
            FCB     %00000000
            FCB     %00000000
            FCB     %00000000
            FCB     %00000000
            ;
            FCB     %00000000           ; Sp
            FCB     %00000000
            FCB     %00000000
            FCB     %00000000
            FCB     %00000000
            FCB     %00000000
            FCB     %00000000
            ;
            FCB     %00000000           ; Sp
            FCB     %00000000
            FCB     %00000000
            FCB     %00000000
            FCB     %00000000
            FCB     %00000000
            FCB     %00000000

            ORG     $FFFE               ; Reset Vector
            FDB     MAIN

            END
