;/*********************************/;
;/* Demo Timer 68HC11 For ET-EXP4 */;
;/* Files Name  : LAB11EX1.ASM    */;
;/* CPU Control : 68HC811E2       */;
;/* Assembler   : AS11NEW.EXE     */;
;/* (Generate Square Wave on PA6) */;
;/*********************************/;
;
;/* Timer Register Address
REGBAS      EQU     $1000                   ; Register base
OC1M        EQU     $0C                     ; OC1 action mask register
OC1D        EQU     $0D                     ; OC1 action data register
TCNT        EQU     $0E                     ; Timer counter register
TOC1        EQU     $16                     ; Output compare 1 register
TOC2        EQU     $18                     ; Output compare 2 register
TOC3        EQU     $1A                     ; Output compare 3 register
TCTL1       EQU     $20                     ; Timer control register 1
TMSK1       EQU     $22                     ; Timer interrupt mask register 1
TFLG1       EQU     $23                     ; Timer interrupt flag register 1
            ;
            ORG     $0000                   ; Internal RAM
HALF_DLY    RMB     2                       ; 16Bit Buffer(1/2 Cycle Delay)
            ;
            ORG     $F800                   ; Start of Main Program
MAIN        LDS     #$FF                    ; Stack Internal RAM
            LDD     #2000                   ; (2000x0.5uS) / 2
            STD     HALF_DLY                ; Defualt = 500Hz Frequency
            ;
            LDX     #REGBAS
            LDAA    #%01000000              ; OM2:OL2 = 0:1 (Toggle OC2)
            STAA    TCTL1,X                 ; OC2 Toggle When Overflow
            STAA    TFLG1,X                 ; Clear OC2F (Clear Overflow Flag)
            STAA    TMSK1,X                 ; Set OC2I (Enable OC2 Interupt)
            CLI                             ; Enable Global Interupt
            ;
            BRA     *                       ; Loop Here For Interupt

;/***********************/;
;/ OC2 Interupt Service */;
;/***********************/;
;
OC2_INT     LDD     HALF_DLY                ; Get Delay Count
            ADDD    TOC2,X                  ; TOC2 = Old TOC2 + HALF_DLY
            STD     TOC2,X
            BCLR    TFLG1,X %10111111       ; Clear OC2F Flag
            RTI

            ORG     $FFE6
            FDB     OC2_INT                 ; OC2 Interupt Service
            ORG     $FFFE
            FDB     MAIN                    ; Reset Vector

            END

